Incoming event notifications for your configured webhook URL.
The Webhooks API is a streamlined way to build apps that respond to activities in White Circle. When you use the Webhooks API, White Circle calls you.
Subscribing to events
To begin working with the Webhooks API, you’ll need to create a Deployment if you haven’t already. While managing your deployment, find the Webhooks page there.
Available event types
Receiving events
Your webhook URL will receive a request for each event type you select. One request = one event.
Error handling
Return an HTTP 200 OK for every event your webhook successfully receives.
Failure conditions
We consider any of these scenarios a single failure condition:
- We’re unable to negotiate or validate your server’s SSL certificate.
- We wait longer than 3 seconds to receive a valid response from your server.
- We receive any other response than an HTTP 200-series response.
Retries
We’ll retry a failed request up to 3 times in a gradually increasing timetable:
- The first retry is sent almost immediately.
- The second retry will be attempted after 2 seconds.
- The third and final retry will be sent after 4 seconds.
Verifying requests from White Circle
Using signed secrets, you can verify that requests from White Circle are authentic.
Understanding signed secrets
You can verify requests from White Circle by verifying signatures using your signing secret.
On each HTTP request that White Circle sends, White Circle adds an X-Whitecircle-Signature HTTP header (or x-whitecircle-signature — header names are meant to be case-insensitive, so the letter case should not be assumed).
The signature is created by hashing the request body with the SHA-256 function, and combining it with an HMAC signing secret. The resulting signature is unique to each request and doesn’t contain any sensitive information.
Request signing follows this pattern:
- Your app receives a request from White Circle.
- Your app computes a signature based on the request.
- You make sure the signature you’ve computed matches the signature on the request.
Let’s go over the recipe for this signature.
Validating a request
Grab your Signing Secret and the raw request body
Python
>>> whitecircle_signing_secret = 'MY_WHITECIRCLE_SIGNING_SECRET'
>>> request_body = request.text
'{"event_type":"review_auto.completed","violation":true,"internal_id":"2e9f6747-045a-4713-9a60-8c166203fce7","violations":{"4fa864e4-9af1-43b6-9fbb-33627980041f":{"violation":true,"violation_source":["text"]},"35822a7e-dc4d-4b9a-a27b-c088e8c73f1c":{"violation":false,"violation_source":["text"]},"069167bb-bda5-4b2a-b012-e3ca78944951":{"violation":false,"violation_source":["text"]}}}'Extract the timestamp header from the request
The signature depends on the timestamp to protect against replay attacks. While you’re extracting the timestamp, check to make sure that the request occurred recently. In this example, we verify that the timestamp does not differ from local time by more than five minutes.
Python
>>> import time
>>> timestamp = request.headers['X-Whitecircle-Request-Timestamp']
'1752847035'
>>> time.time() - int(timestamp) < 5 * 60
TrueConcatenate the version number, the timestamp, and the request body together, using a colon (:) as a delimiter
Python
>>> sig_basestring = 'v0:' + timestamp + ':' + request_body
'v0:1752847035:{"event_type":"review_auto.completed","violation":true,"internal_id":"2e9f6747-045a-4713-9a60-8c166203fce7","violations":{"4fa864e4-9af1-43b6-9fbb-33627980041f":{"violation":true,"violation_source":["text"]},"35822a7e-dc4d-4b9a-a27b-c088e8c73f1c":{"violation":false,"violation_source":["text"]},"069167bb-bda5-4b2a-b012-e3ca78944951":{"violation":false,"violation_source":["text"]}}}'Hash the resulting string, using the signing secret as a key, and taking the hex digest of the hash
Python
>>> import hmac
>>> import hashlib
>>> my_signature = 'v0=' + hmac.new(whitecircle_signing_secret.encode(), sig_basestring.encode(), hashlib.sha256).hexdigest()
'v0=37a8f9210398d5f370b2a10a4413ca16075d373e0c418d14c83ad71354912fbd'Compare the resulting signature to the header on the request
Python
>>> whitecircle_signature = request.headers['X-Whitecircle-Signature']
>>> hmac.compare_digest(my_signature, whitecircle_signature)
TrueDone!
That’s it! You may now proceed with processing the update.
Headers
X-Whitecircle-Request-TimestampstringrequiredUnix timestamp (seconds) when the request was signed to protect against replay attacks.
Example:
"1752847035"X-Whitecircle-SignaturestringrequiredSignature for the request body computed as HMAC-SHA256 over 'v0:{timestamp}:{raw_body}', prefixed with 'v0='.
Example:
"v0=37a8f9210398d5f370b2a10a4413ca16075d373e0c418d14c83ad71354912fbd"
Body
application/json
event_typeenum<string>requiredType of the event
Available options:
review_manual.in_progress,review_manual.completed,review_auto.completedviolationbooleanrequiredWhether any policy violations were detected in the session
internal_idstringrequiredUnique internal identifier for the session
violationsobjectrequiredMap of policy IDs to their changed verdicts (only changed policies included)
Show child attributesHide child attributes
external_idstring | nullOptional external identifier provided by client
Response
Successfully received
Bad request